# Developer Docs Documentation > The Developer Docs is where you'll find comprehensive guides and documentation to help you start working with Bob as quickly as possible. Fetch the complete documentation index at: https://apidocs.hibob.com/llms.txt. Use this file to discover all available pages before exploring further. Append .md to any documentation page URL to get its markdown version. ## API Reference: Goals API - [Goals](https://apidocs.hibob.com/reference/goals.md): The Goals API provides access to goals and key results in your company. - [Get Goal Type Metadata](https://apidocs.hibob.com/reference/get_goals-goal-types-metadata.md): Returns the goal type fields. - [Get Goals Metadata](https://apidocs.hibob.com/reference/get_goals-goals-metadata.md): Returns the Goal fields. - [Get Key Results Metadata](https://apidocs.hibob.com/reference/get_goals-goals-key-results-metadata.md): Returns the key result fields. - [Get Goal Cycle Metadata](https://apidocs.hibob.com/reference/get_goals-goal-cycles-metadata.md): Returns the goal cycle fields metadata schema. - [Search Goal Types](https://apidocs.hibob.com/reference/post_goals-goal-types-search.md): Search for the available Goal Types using filters and pagination parameters.
**Note**: Pagination parameters are currently accepted but not enforced.

**Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Search Goals](https://apidocs.hibob.com/reference/post_goals-goals-search.md): Search for Goals using filters and pagination parameters.

**Pagination parameters** are currently accepted but not enforced.
**Multiple filters** can be combined in a single request. All filters use AND logic (goals must match ALL specified filters).

**Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Search Key Results](https://apidocs.hibob.com/reference/post_goals-goals-key-results-search.md): Search for Key Results of a specific Goals, using filters. The `goalId` filter is mandatory.
**Note: Pagination parameters are currently accepted but not enforced.**

**Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Search Goal Cycles](https://apidocs.hibob.com/reference/post_goals-goal-cycles-search.md): Search for available goal cycles. Returns all goal cycles accessible to the authenticated user.

**Notes**: - Filters are not supported for this endpoint. Providing filters will result in a 400 error. - Pagination parameters are currently accepted but not enforced. **Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Create Goals](https://apidocs.hibob.com/reference/post_goals-goals.md): Creates multiple goals in a single request using the `items` array.
Each goal will be created with the specified owner and properties.

**Limitations:**
- You can create up to 25 goals per request.
- If the request includes more than 25 goals, the operation will fail and return an error.

The response includes an array of the created Goal IDs.
If any key result fails to be created, a structured error response will be returned with details for each failed item.

**Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Update Goal Status](https://apidocs.hibob.com/reference/patch_goals-goals-goalid-status.md): Updates the status of an existing goal, optionally including a comment.
This endpoint is used to update the status independently from other goal fields such as title, description, or due date.

**Note**: In Bob, status changes are performed through a dedicated workflow (e.g., goal check-ins), which is why this action is exposed via a separate endpoint. - [Update Goal](https://apidocs.hibob.com/reference/patch_goals-goals-goalid.md): Update an existing goal details. Supports partial updates where only the fields that are provided in the request body will be updated.

**Cycle Management**: You can assign a goal to a cycle, move it between cycles, or unassign it from a cycle using the `cycleId` field: - To assign to a cycle: provide a valid cycle ID - To move between cycles: provide a different cycle ID - To unassign from a cycle: provide `null` as the value - To keep the current cycle: omit the field entirely
**Note**: Goal status updates are not supported via this endpoint. Use the Update Goal Status endpoint instead. - [Delete Goal](https://apidocs.hibob.com/reference/delete_goals-goals-goalid.md): Delete an existing goal. This will permanently remove the goal. This action is irreversible. - [Create Key Results](https://apidocs.hibob.com/reference/post_goals-goals-goalid-key-results.md): Creates one or more key results for a specific goal.
Each key result will be created with the specified title, `measureBy` properties, and automatically associated with the given goal.

**Limitations:**
- You can create up to 25 key results per request.
- If the request includes more than 25 items, it will return a 400 error.

The response includes an array of the created key result IDs.
If any key result fails to be created, a structured error response will be returned with details for each failed item.

**Testing notes:**
- Use the testing widget's **Try It!** option to test this endpoint.
- Use the **Examples > Request Example** option to see how to initiate body parameters.
- [Update Key Results Progress](https://apidocs.hibob.com/reference/patch_goals-goals-goalid-key-results-progress.md): Update the progress (check-in) of one or more key results for a specific goal without changing the goal status.

**Note**: This endpoint behaves like the check-in mechanism in Bob, however, it maintains the current goal status, updating only the key result progress. To update the goal status, use the Update Goal Status endpoint.

This endpoint supports optional audit fields at both levels: goal-level comment and key result-level notes. These parameters only affect check-in activity log for auditing purposes. They are not part of the Goal or Key Result entities, and are not returned by search/metadata endpoints. - [Update Key Results Details](https://apidocs.hibob.com/reference/patch_goals-goals-goalid-key-results.md): Update the details of the key results of a given goal. This endpoint supports updating the details: title, measureType, target, currency, and currencySymbol fields only. Each key result update is processed independently with individual success/failure tracking.

**Note:** To update the key result progress (check-in), use the `/goals/goals/{goalId}/key-results/progress` endpoint.
- [Delete a Key Result](https://apidocs.hibob.com/reference/delete_goals-goals-goalid-key-results-keyresultid.md): Delete a specific key result from a goal. This completely removes the key result.
**Important:** This action is irreversible. The key result and all its progress history will be permanently deleted.